'use strict';

var React = require('react');
var classNames = require('classnames');

var Button = React.createClass({
  displayName: 'Button',


  propTypes: {
    children: React.PropTypes.node.isRequired,
    className: React.PropTypes.oneOfType([React.PropTypes.string, React.PropTypes.arrayOf(React.PropTypes.string)]),
    href: React.PropTypes.string,
    isDisabled: React.PropTypes.bool,
    isFilled: React.PropTypes.bool,
    isPrimary: React.PropTypes.bool,
    isSecondary: React.PropTypes.bool,
    isSmall: React.PropTypes.bool,
    onClick: React.PropTypes.func,
    tabIndex: React.PropTypes.number,
    target: React.PropTypes.string,
    type: React.PropTypes.string
  },

  getDefaultProps: function getDefaultProps() {
    return { type: 'button' };
  },

  render: function render() {
    var props = {
      className: classNames('pl-button', this.props.className, {
        'pl-disabled': this.props.isDisabled,
        'pl-filled': this.props.isFilled,
        'pl-primary': this.props.isPrimary,
        'pl-secondary': this.props.isSecondary,
        'pl-small': this.props.isSmall
      }),
      tabIndex: this.props.tabIndex
    };
    if (!this.props.isDisabled) {
      if (this.props.href) {
        props.href = this.props.href;
        props.target = this.props.target;
      } else {
        props.onClick = this.props.onClick;
        props.type = this.props.type;
      }
    }
    return React.createElement(this.props.href ? 'a' : 'button', props, this.props.children);
  }
});

module.exports = Button;