'use strict';

var React = require('react');
var classNames = require('classnames');

var Icon = require('./icon');
var Overlay = require('./overlay');

var keys = require('../../util/keys');

var Dialog = React.createClass({
  displayName: 'Dialog',


  propTypes: {
    children: React.PropTypes.node,
    className: React.PropTypes.oneOfType([React.PropTypes.string, React.PropTypes.arrayOf(React.PropTypes.string)]),
    isLarge: React.PropTypes.bool,
    isSmall: React.PropTypes.bool,
    onClose: React.PropTypes.func
  },

  componentWillMount: function componentWillMount() {
    window.addEventListener('keydown', this._onKeyDown, true);
  },

  componentWillUnmount: function componentWillUnmount(nextProps) {
    window.removeEventListener('keydown', this._onKeyDown, true);
  },

  _onKeyDown: function _onKeyDown(event) {
    event.stopPropagation();
    if (event.keyCode === keys.ESC) {
      this.props.onClose();
    }
  },

  render: function render() {
    var dialogClassName = classNames('pl-dialog', this.props.className, {
      'pl-large': this.props.isLarge,
      'pl-small': this.props.isSmall
    });
    return React.createElement(
      Overlay,
      { className: dialogClassName, onDimClick: this.props.onClose },
      this.props.children,
      this.props.onClose && React.createElement(
        'div',
        { className: 'pl-dialog-close', onClick: this.props.onClose },
        React.createElement(Icon, { name: 'close' })
      )
    );
  }
});

module.exports = Dialog;