'use strict';

var React = require('react');
var classNames = require('classnames');
var includeFolder = require('include-folder');

var icons = includeFolder('src/assets/icons');

var parser = new DOMParser();

var Icon = React.createClass({
  displayName: 'Icon',


  propTypes: {
    className: React.PropTypes.oneOfType([React.PropTypes.string, React.PropTypes.arrayOf(React.PropTypes.string)]),
    name: React.PropTypes.string.isRequired,
    size: React.PropTypes.oneOfType([React.PropTypes.number, React.PropTypes.oneOf(['small', 'large'])])
  },

  render: function render() {

    if (!icons[this.props.name]) {
      return null;
    }

    var iconClassName = classNames('pl-icon', this.props.className, {
      'pl-small': this.props.size === 'small',
      'pl-large': this.props.size === 'large'
    });
    var iconStyle = typeof this.props.size === 'number' ? { width: this.props.size, height: this.props.size } : null;

    var shapes = [];
    var icon = parser.parseFromString(icons[this.props.name], 'image/svg+xml').childNodes[0];
    for (var i = 0; i < icon.childNodes.length; i++) {
      var childNode = icon.childNodes.item(i);
      if (childNode.nodeType === 1 && childNode.tagName !== 'title') {
        var attributes = Array.prototype.slice.call(childNode.attributes, 0);
        shapes.push({
          tagName: childNode.tagName,
          attributes: attributes.reduce(function (a, b) {
            a[b.name] = b.value;
            return a;
          }, {})
        });
      }
    }

    return React.createElement(
      'svg',
      { className: iconClassName,
        style: iconStyle,
        viewBox: icon.attributes.viewBox.value,
        xmlns: 'http://www.w3.org/2000/svg' },
      shapes.map(function (shape, index) {
        return React.createElement(shape.tagName, Object.assign({ key: index }, shape.attributes));
      })
    );
  }
});

module.exports = Icon;