'use strict';

var React = require('react');
var classNames = require('classnames');

var Overlay = React.createClass({
  displayName: 'Overlay',


  propTypes: {
    children: React.PropTypes.node.isRequired,
    className: React.PropTypes.oneOfType([React.PropTypes.string, React.PropTypes.arrayOf(React.PropTypes.string)]),
    onDimClick: React.PropTypes.func,
    onDragEnter: React.PropTypes.func,
    onDragLeave: React.PropTypes.func,
    onDragOver: React.PropTypes.func,
    onDrop: React.PropTypes.func
  },

  render: function render() {
    var overlayClassName = classNames('pl-overlay', this.props.className);
    return React.createElement(
      'div',
      { className: overlayClassName,
        onDragEnter: this.props.onDragEnter,
        onDragLeave: this.props.onDragLeave,
        onDragOver: this.props.onDragOver,
        onDrop: this.props.onDrop },
      React.createElement('div', { className: 'pl-overlay-dim', onClick: this.props.onDimClick }),
      React.createElement(
        'div',
        { className: 'pl-overlay-content' },
        this.props.children
      ),
      '}'
    );
  }
});

module.exports = Overlay;