'use strict';

var React = require('react');
var classNames = require('classnames');

var TabMenu = React.createClass({
  displayName: 'TabMenu',


  propTypes: {
    activeIndex: React.PropTypes.number,
    tabs: React.PropTypes.array
  },

  getInitialState: function getInitialState() {
    return {
      activeIndex: this.props.activeIndex || 0
    };
  },

  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    if (nextProps.activeIndex !== this.props.activeIndex) {
      this.setState({ activeIndex: nextProps.activeIndex });
    }
  },

  _onMenuItemClick: function _onMenuItemClick(index) {
    this.setState({ activeIndex: index });
  },

  render: function render() {
    var _this = this;

    return React.createElement(
      'div',
      { className: 'pl-tab-menu' },
      React.createElement(
        'div',
        { className: 'pl-tab-menu-header' },
        this.props.tabs.map(function (tab, index) {
          var headerItemClassName = classNames('pl-tab-menu-header-item', {
            'pl-active': index === _this.state.activeIndex
          });
          return React.createElement(
            'div',
            { className: headerItemClassName,
              key: index,
              onClick: _this._onMenuItemClick.bind(null, index) },
            tab.title
          );
        })
      ),
      React.createElement(
        'div',
        { className: 'pl-tab-menu-slides' },
        React.createElement(
          'div',
          { className: 'pl-tab-menu-slider',
            style: { transform: 'translateX(' + this.state.activeIndex * -100 + '%)' } },
          this.props.tabs.map(function (tab, index) {
            return React.createElement(
              'div',
              { className: 'pl-tab-menu-slide', key: index },
              tab.content
            );
          })
        )
      )
    );
  }
});

module.exports = TabMenu;