'use strict';

var React = require('react');
var classNames = require('classnames');

var Toggle = React.createClass({
  displayName: 'Toggle',


  propTypes: {
    isToggled: React.PropTypes.bool.isRequired,
    label: React.PropTypes.string,
    name: React.PropTypes.string,
    onToggle: React.PropTypes.func.isRequired
  },

  _onToggle: function _onToggle() {
    this.props.onToggle(!this.props.isToggled);
  },

  render: function render() {
    var toggleClassName = classNames('pl-toggle', {
      'pl-toggled': this.props.isToggled
    });
    return React.createElement(
      'div',
      { className: toggleClassName, onClick: this._onToggle },
      React.createElement('input', { checked: this.props.isToggled,
        name: this.props.name,
        readOnly: true,
        type: 'checkbox' }),
      React.createElement(
        'div',
        { className: 'pl-toggle-switch' },
        React.createElement('div', { className: 'pl-toggle-switch-track' }),
        React.createElement('div', { className: 'pl-toggle-switch-handle' })
      ),
      this.props.label && React.createElement(
        'label',
        null,
        this.props.label
      ),
      React.createElement('div', { className: 'pl-clear' })
    );
  }
});

module.exports = Toggle;