'use strict';

var React = require('react');
var classNames = require('classnames');

var Tooltip = React.createClass({
  displayName: 'Tooltip',


  propTypes: {
    children: React.PropTypes.node,
    className: React.PropTypes.oneOfType([React.PropTypes.string, React.PropTypes.arrayOf(React.PropTypes.string)]),
    onClick: React.PropTypes.func,
    position: React.PropTypes.string
  },

  render: function render() {

    var tooltipClassName = classNames('pl-tooltip', this.props.className);

    var position = this.props.position ? this.props.position.split(' ').slice(0, 2) : [];
    var tooltipLabelClassName = classNames('pl-tooltip-label', {
      'pl-top': position.indexOf('top') !== -1,
      'pl-right': position.indexOf('right') !== -1,
      'pl-bottom': position.indexOf('bottom') !== -1,
      'pl-left': position.indexOf('left') !== -1
    });

    return React.createElement(
      'div',
      { className: tooltipClassName, onClick: this.props.onClick },
      React.createElement('div', { className: 'pl-tooltip-target' }),
      React.createElement(
        'div',
        { className: tooltipLabelClassName },
        this.props.children
      )
    );
  }
});

module.exports = Tooltip;